/*
 * Click nbfs://nbhost/SystemFileSystem/Templates/Licenses/license-default.txt to change this license
 * Click nbfs://nbhost/SystemFileSystem/Templates/GUIForms/JFrame.java to edit this template
 */

package turbowin;

import java.awt.Color;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;
import java.util.concurrent.ExecutionException;
import javax.swing.JDialog;
import javax.swing.JMenuItem;
import javax.swing.JOptionPane;
import javax.swing.JPopupMenu;
import javax.swing.SwingWorker;
import javax.swing.Timer;

/**
 *
 * @author marti
 */
public class Obs_Stats_view extends javax.swing.JFrame {

   
   /* inner class popupListener */
   class PopupListener extends MouseAdapter 
   {
      @Override
      public void mousePressed(MouseEvent e) 
      {
         maybeShowPopup(e);
      }
      @Override
      public void mouseReleased(MouseEvent e) 
      {
         maybeShowPopup(e);
      }

      private void maybeShowPopup(MouseEvent e) 
      {
         if (e.isPopupTrigger()) 
         {
            popup.show(e.getComponent(), e.getX(), e.getY());
         }
      }
   }      
      
   
   
   
   /** Creates new form Obs_Stats_view */
   public Obs_Stats_view() {
       initComponents();
       initComponents1();
       prepare_immt_log();
   }

   
   
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
   // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
   private void initComponents() {

      jPanel5 = new javax.swing.JPanel();
      jPanel4 = new javax.swing.JPanel();
      jPanel3 = new javax.swing.JPanel();
      jLabel2 = new javax.swing.JLabel();
      jPanel2 = new javax.swing.JPanel();
      jLabel1 = new javax.swing.JLabel();
      /*
      jPanel1 = new javax.swing.JPanel();
      */jPanel1 = new Obs_Stats_graph();

      setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);

      javax.swing.GroupLayout jPanel5Layout = new javax.swing.GroupLayout(jPanel5);
      jPanel5.setLayout(jPanel5Layout);
      jPanel5Layout.setHorizontalGroup(
         jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
         .addGap(0, 100, Short.MAX_VALUE)
      );
      jPanel5Layout.setVerticalGroup(
         jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
         .addGap(0, 510, Short.MAX_VALUE)
      );

      getContentPane().add(jPanel5, java.awt.BorderLayout.LINE_START);

      javax.swing.GroupLayout jPanel4Layout = new javax.swing.GroupLayout(jPanel4);
      jPanel4.setLayout(jPanel4Layout);
      jPanel4Layout.setHorizontalGroup(
         jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
         .addGap(0, 100, Short.MAX_VALUE)
      );
      jPanel4Layout.setVerticalGroup(
         jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
         .addGap(0, 510, Short.MAX_VALUE)
      );

      getContentPane().add(jPanel4, java.awt.BorderLayout.LINE_END);

      jLabel2.setHorizontalAlignment(javax.swing.SwingConstants.TRAILING);
      jLabel2.setText("--- right click for night colors ---");

      javax.swing.GroupLayout jPanel3Layout = new javax.swing.GroupLayout(jPanel3);
      jPanel3.setLayout(jPanel3Layout);
      jPanel3Layout.setHorizontalGroup(
         jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
         .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel3Layout.createSequentialGroup()
            .addContainerGap(405, Short.MAX_VALUE)
            .addComponent(jLabel2, javax.swing.GroupLayout.PREFERRED_SIZE, 448, javax.swing.GroupLayout.PREFERRED_SIZE)
            .addGap(100, 100, 100))
      );
      jPanel3Layout.setVerticalGroup(
         jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
         .addGroup(jPanel3Layout.createSequentialGroup()
            .addContainerGap()
            .addComponent(jLabel2)
            .addContainerGap(78, Short.MAX_VALUE))
      );

      getContentPane().add(jPanel3, java.awt.BorderLayout.PAGE_END);

      javax.swing.GroupLayout jPanel2Layout = new javax.swing.GroupLayout(jPanel2);
      jPanel2.setLayout(jPanel2Layout);
      jPanel2Layout.setHorizontalGroup(
         jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
         .addGroup(jPanel2Layout.createSequentialGroup()
            .addGap(100, 100, 100)
            .addComponent(jLabel1, javax.swing.GroupLayout.PREFERRED_SIZE, 750, javax.swing.GroupLayout.PREFERRED_SIZE)
            .addContainerGap(103, Short.MAX_VALUE))
      );
      jPanel2Layout.setVerticalGroup(
         jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
         .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel2Layout.createSequentialGroup()
            .addContainerGap(78, Short.MAX_VALUE)
            .addComponent(jLabel1)
            .addContainerGap())
      );

      getContentPane().add(jPanel2, java.awt.BorderLayout.PAGE_START);

      jPanel1.setBackground(new java.awt.Color(255, 250, 240));
      jPanel1.setPreferredSize(new java.awt.Dimension(800, 560));

      javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
      jPanel1.setLayout(jPanel1Layout);
      jPanel1Layout.setHorizontalGroup(
         jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
         .addGap(0, 753, Short.MAX_VALUE)
      );
      jPanel1Layout.setVerticalGroup(
         jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
         .addGap(0, 510, Short.MAX_VALUE)
      );

      getContentPane().add(jPanel1, java.awt.BorderLayout.CENTER);

      pack();
   }// </editor-fold>//GEN-END:initComponents

   
   /***********************************************************************************************/
   /*                                                                                             */
   /*                                                                                             */
   /*                                                                                             */
   /***********************************************************************************************/
   private void initComponents1()
   {
      // title
      if (main.obs_stats_mode.equals(main.OBSERVERS_STATS))
      {   
         setTitle(main.APPLICATION_NAME + " Observers Statistics");  
      }
      else if (main.obs_stats_mode.equals(main.OBSERVATIONS_STATS))
      {
         setTitle(main.APPLICATION_NAME + " Observations Statistics");
      }
      
      /* background colors main panel (set by main menu theme option) */
      if (main.theme_mode.equals(main.THEME_NIMBUS_NIGHT))
      {
         night_vision = true;
        
         // set to the night colors
         jPanel1.setBackground(CENTRE_PANEL_NIGHT_COLOR);  
         jPanel2.setBackground(SIDE_PANELS_NIGHT_COLOR);
         jPanel3.setBackground(SIDE_PANELS_NIGHT_COLOR);
         jPanel4.setBackground(SIDE_PANELS_NIGHT_COLOR);
         jPanel5.setBackground(SIDE_PANELS_NIGHT_COLOR); 
      }
      else
      {
         night_vision = false;
         
         jPanel1.setBackground(CENTRE_PANEL_DAY_COLOR);  
         jPanel2.setBackground(SIDE_PANELS_DAY_COLOR);
         jPanel3.setBackground(SIDE_PANELS_DAY_COLOR);
         jPanel4.setBackground(SIDE_PANELS_DAY_COLOR);
         jPanel5.setBackground(SIDE_PANELS_DAY_COLOR);        
      } 
   
      /* background colors main panel (set by popup menu option) */
      popup = new JPopupMenu();
      
      JMenuItem menuItem = new JMenuItem("night colors");
      menuItem.addActionListener(new java.awt.event.ActionListener() 
      {
         @Override
         public void actionPerformed(ActionEvent e) 
         {
            night_vision = true;
           
            jPanel1.setBackground(CENTRE_PANEL_NIGHT_COLOR);  
            jPanel2.setBackground(SIDE_PANELS_NIGHT_COLOR);
            jPanel3.setBackground(SIDE_PANELS_NIGHT_COLOR);
            jPanel4.setBackground(SIDE_PANELS_NIGHT_COLOR);
            jPanel5.setBackground(SIDE_PANELS_NIGHT_COLOR);  
         }
      });
      popup.add(menuItem);
      
      JMenuItem menuItem2 = new JMenuItem("day colors");
      menuItem2.addActionListener(new java.awt.event.ActionListener() 
      {
         @Override
         public void actionPerformed(ActionEvent e) 
         {
            night_vision = false;
            
            jPanel1.setBackground(CENTRE_PANEL_DAY_COLOR);  
            jPanel2.setBackground(SIDE_PANELS_DAY_COLOR);
            jPanel3.setBackground(SIDE_PANELS_DAY_COLOR);
            jPanel4.setBackground(SIDE_PANELS_DAY_COLOR);
            jPanel5.setBackground(SIDE_PANELS_DAY_COLOR); 
         }
      });
      popup.add(menuItem2);  

      MouseListener popupListener = new Obs_Stats_view.PopupListener();
      addMouseListener(popupListener);
      
   }
   
   
   
   /***********************************************************************************************/
   /*                                                                                             */
   /*                                                                                             */
   /*                                                                                             */
   /***********************************************************************************************/
   private void prepare_immt_log()
   {
      Boolean doorgaan = true;
      
      
      // check logs dir
      if (main.logs_dir.trim().equals("") == true || main.logs_dir.trim().length() < 2)
      {
         String info = "logs folder unknown, select: Maintenance -> Log files settings";
         JOptionPane.showMessageDialog(null, info, main.APPLICATION_NAME + " error", JOptionPane.WARNING_MESSAGE);
         doorgaan = false;
      }
      
      // check immt log
      if (doorgaan)
      {
         String volledig_path_immt = main.logs_dir + java.io.File.separator + main.IMMT_LOG;

         File immt_file = new File(volledig_path_immt);
         if (immt_file.exists() && immt_file.length() > 0)    // length() in bytes
         {
            doorgaan = true;
         }  
         else
         {
            String info = "No stored observations (immt.log) found on this computer";
            JOptionPane.showMessageDialog(null, info, main.APPLICATION_NAME + " error", JOptionPane.WARNING_MESSAGE);
            doorgaan = false;
         } // else      
      }   
      
      // logs dir ok and immt log ok
      if (doorgaan)
      {
         // temporary message box (Processing can take a while)
         String info = "Processing and displaying can take up to 1 minute";
         final JOptionPane pane_message = new JOptionPane(info, JOptionPane.INFORMATION_MESSAGE, JOptionPane.DEFAULT_OPTION, null, new Object[]{}, null);
         final JDialog pane_message_dialog = pane_message.createDialog(main.APPLICATION_NAME);

         Timer timer_message = new Timer(1000, new ActionListener()
         {
            @Override
            public void actionPerformed(ActionEvent e)
            {
               pane_message_dialog.dispose();
            }
         });
         timer_message.setRepeats(false);
         timer_message.start();
         pane_message_dialog.setVisible(true);

         // temporary (modaless) dialog box "Processing, Please wait"
         final processing processing_dialog = new processing();     
         processing_dialog.setSize(400, 300);
         processing_dialog.setVisible(true); 
         
         new SwingWorker<Integer, Void>()
         {
            @Override
            protected Integer doInBackground() throws Exception
            {
               immt_list = new ArrayList<>();           // size is now dynamically
               String record = "";
               Integer return_immt = 0;
               
               String volledig_path_immt = main.logs_dir + java.io.File.separator + main.IMMT_LOG;
                     
               try (BufferedReader in = new BufferedReader(new FileReader(volledig_path_immt))) // try with resources
               {   
                  while ((record = in.readLine()) != null)
                  {
                     try
                     {   
                        if (record.length() >= main.IMMT_5_LENGTH)                       // avoiding that empty records will be added                      
                        {   
                           immt_list.add(record);
                        }    
                     }
                     catch (UnsupportedOperationException e)
                     {
                        return_immt = -1;
                     }   
                  } // while ((record = in.readLine()) != null)
               }  
               catch (IOException ex) 
               {
                  return_immt = -2;
               }
               

               //
               //////////////// count the number of different observer names because only a limited number can be displayed as bars in the graph
               //               NB only appropriate in the observers stats mode
               //
               if (main.obs_stats_mode.equals(main.OBSERVERS_STATS))
               {
                  int test_different_observer_names = 0;
                  String test_observers_names_array[] = new String[MAX_NUMBER_OBSERVERS_TEST];
                  for (int i = 0; i < MAX_NUMBER_OBSERVERS_TEST; i++)
                  {
                     test_observers_names_array[i] = "";
                  }     

                  for (String obs : immt_list) 
                  {
                     String observer_name        = "";
                     boolean observer_name_found = false;

                     if (obs.length() > main.IMMT_5_POSITION_OBSERVER - 1)                            // main.IMMT_5_POSITION_OBSERVER - 1 = 172
                     {   
                        observer_name              = obs.substring(main.IMMT_5_POSITION_OBSERVER);    // main.IMMT_5_POSITION_OBSERVER = 173

                        for (int i = 0; i < MAX_NUMBER_OBSERVERS_TEST; i++)
                        {   
                           if (test_observers_names_array[i].equals(observer_name) && (!observer_name.equals("")) )
                           {
                              observer_name_found = true;
                              break;
                           }

                        } // for (int i = 0; i < 10000; i++) 

                        if (observer_name_found == false)
                        {
                           for (int i = 0; i < MAX_NUMBER_OBSERVERS_TEST; i++)
                           {
                              if (test_observers_names_array[i].equals("") && (!observer_name.equals("")))
                              {
                                 test_observers_names_array[i] = observer_name;
                                 break;
                              }      
                           } // for (int i = 0; i < MAX_NUMBER_OBSERVERS_BARS; i++)
                        } // if (observer_name_found == false)

                     } // if (obs.length() > main.IMMT_5_POSITION_OBSERVER - 1) 
                  } // for (String obs : immt_list)   


                  // count number of different observer names
                  for (int i = 0; i < MAX_NUMBER_OBSERVERS_TEST; i++)
                  {
                     if (test_observers_names_array[i].equals("") == false)
                     {
                        test_different_observer_names++;
                     }   
                  } // for (int i = 0; i < MAX_NUMBER_OBSERVERS_TEST; i++)           

                  if (test_different_observer_names > MAX_NUMBER_OBSERVERS_NAMES)   
                  {
                     return_immt = -3;
                  }
               } // if (main.obs_stats_mode.equals(main.OBSERVERS_STATS))   
      
               
               return return_immt; 
               
            } // protected Void doInBackground() throws Exception
         
            @Override
            protected void done()
            {
               processing_dialog.dispose(); // NB actually it closes much too early, but also putting the closing statement in another functions (eg in display_IMMT_on_leaflet_map()) , the result is the same (too early)
               try
               {
                  int return_immt = get();
                  if (return_immt == 0)
                  {
                     immt_log_ok = true;
                     repaint();
                  }  
                  else if (return_immt == -1)
                  {
                     immt_log_ok = false;
                     String info = "Error when creating immt.log list";
                     JOptionPane.showMessageDialog(null, info, main.APPLICATION_NAME + " error", JOptionPane.WARNING_MESSAGE);
                  }  
                  else if (return_immt == -2)
                  {
                     immt_log_ok = false;
                     String info = "Error when opening immt.log";
                     JOptionPane.showMessageDialog(null, info, main.APPLICATION_NAME + " error", JOptionPane.WARNING_MESSAGE);
                  }   
                  else if (return_immt == -3)
                  {
                     immt_log_ok = false;
                     String info = "> " + MAX_NUMBER_OBSERVERS_NAMES + " different observer names recorded in immt.log. Please send logs to your Port Meteorological Officer";
                     JOptionPane.showMessageDialog(null, info, main.APPLICATION_NAME + " warning", JOptionPane.WARNING_MESSAGE);
                  }  
                  
               } 
               catch (InterruptedException | ExecutionException ex) 
               {
                  String info = "internal error :" + ex;
                  JOptionPane.showMessageDialog(null, info, main.APPLICATION_NAME + " error", JOptionPane.WARNING_MESSAGE);
               }
               
            } // protected void done()
         
         }.execute(); // new SwingWorker<Integer, Void>()        
      } // if doorgaan
   } // private void initComponents1()
   
   
    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        /* Set the Nimbus look and feel */
        //<editor-fold defaultstate="collapsed" desc=" Look and feel setting code (optional) ">
        /* If Nimbus (introduced in Java SE 6) is not available, stay with the default look and feel.
         * For details see http://download.oracle.com/javase/tutorial/uiswing/lookandfeel/plaf.html 
         */
        try {
            for (javax.swing.UIManager.LookAndFeelInfo info : javax.swing.UIManager.getInstalledLookAndFeels()) {
                if ("Nimbus".equals(info.getName())) {
                    javax.swing.UIManager.setLookAndFeel(info.getClassName());
                    break;
                }
            }
        } catch (ClassNotFoundException ex) {
            java.util.logging.Logger.getLogger(Obs_Stats_view.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (InstantiationException ex) {
            java.util.logging.Logger.getLogger(Obs_Stats_view.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (IllegalAccessException ex) {
            java.util.logging.Logger.getLogger(Obs_Stats_view.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (javax.swing.UnsupportedLookAndFeelException ex) {
            java.util.logging.Logger.getLogger(Obs_Stats_view.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        }
        //</editor-fold>

        /* Create and display the form */
        java.awt.EventQueue.invokeLater(new Runnable() {
            @Override
            public void run() {
                new Obs_Stats_view().setVisible(true);
            }
        });
    }

   // Variables declaration - do not modify//GEN-BEGIN:variables
   public static javax.swing.JLabel jLabel1;
   private javax.swing.JLabel jLabel2;
   /*
   private javax.swing.JPanel jPanel1;
   */private Obs_Stats_graph jPanel1;
   private javax.swing.JPanel jPanel2;
   private javax.swing.JPanel jPanel3;
   private javax.swing.JPanel jPanel4;
   private javax.swing.JPanel jPanel5;
   // End of variables declaration//GEN-END:variables
   
   private static final Color CENTRE_PANEL_DAY_COLOR                           = new Color(255, 250, 240); 
   private static final Color SIDE_PANELS_DAY_COLOR                            = Color.LIGHT_GRAY; //new Color(242, 242, 242);
   private static final Color CENTRE_PANEL_NIGHT_COLOR                         = Color.DARK_GRAY; 
   private static final Color SIDE_PANELS_NIGHT_COLOR                          = Color.BLACK;
   public static final Color BAR_OBSERVERS_DAY_COLOR                           = new Color(0, 204, 102);          // light green  
   public static final Color BAR_OBSERVERS_NIGHT_COLOR                         = Color.RED;
   public static final Color BAR_OBSERVATIONS_DAY_COLOR                        = new Color(0, 150, 255);            // light blue 
   public static final Color BAR_OBSERVATIONS_NIGHT_COLOR                      = Color.RED;
   public static final int MAX_NUMBER_OBSERVERS_NAMES                          = 50;
   public static final int MAX_NUMBER_OBSERVERS_TEST                           = MAX_NUMBER_OBSERVERS_NAMES + 1;    // only for determining the number of different observer names before the actual painting
   public static final int NUMBER_PARAMETERS                                   = 11;                                // air pressure, temp, sst, wavs etc.
      
   private JPopupMenu popup;
   
   public static List<String> immt_list;
   public static boolean immt_log_ok;
   public static boolean night_vision;
}
